defmodule DecentralisedBookIndex.Sync.AuthorSync do
  alias DecentralisedBookIndex.Metadata
  alias DecentralisedBookIndex.Metadata.Author

  def create_update(attrs, server_id) do
    case Metadata.get_author_by_id(attrs.id) do
      {:ok, author} ->
        attrs =
          attrs
          |> Map.delete(:id)
          |> Map.delete(:author_alias_registry_id)
          |> Map.put(:dbi_server_id, server_id)

        author
        |> Ash.Changeset.for_update(:sync, attrs)
        |> Ash.update!()

        :ok
      {:error, %Ash.Error.Query.NotFound{}} ->
        attrs =
          attrs
          |> Map.put(:dbi_server_id, server_id)

        Author
        |> Ash.Changeset.for_create(:sync_create, attrs)
        |> Ash.create!()

        :ok
    end
  end
end
