defmodule DecentralisedBookIndex.Metadata.Forms.AuthorFormTest do
  use DecentralisedBookIndex.DataCase, async: true

  alias DecentralisedBookIndex.Metadata

  describe "create new author via the form" do
    test "just name and description" do
      user = generate(user())
      valid_params = %{
        "name" => "Oleh",
        "description" => "A cool author",
      }

      form = \
        AshPhoenix.Form.for_create(Metadata.Author, :create,
          as: "author",
          actor: user
        )

      assert {:ok, user} = AshPhoenix.Form.submit(form, params: valid_params)
    end
  end

  describe "update existing author via the form" do
    test "update author's name" do
      user = generate(user())
      author = generate(author())

      valid_params = %{
        "name" => "Another Oleh",
        "description" => "A cool author",
      }

      form =
        AshPhoenix.Form.for_update(author, :update,
          as: "author",
          actor: user
        )

      assert {:ok, user} = AshPhoenix.Form.submit(form, params: valid_params)
    end
  end
end
